#
# @summary Return an array of resources currently in the catalog
#
# @param [String[1]] resource_type The resource type to search for in the catalog
# @returns [Array] Array of all resources of specified resource type
#
# See the file "LICENSE" for the full license governing this code.
#
Puppet::Functions.create_function(:'easy_type::resources_in_catalog') do
  dispatch :resources_in_catalog do
    param 'String[1]', :resource_type
    return_type 'Array'
  end

  def resources_in_catalog( resource_type)
    catalog = closure_scope.catalog
    entries = catalog.resources.select  {|e| e.type == resource_type}
  end
end
  
  