#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:ensure) do
  include EasyType

  desc <<-EOD
      absent, present or updated.

      when absent is specified, the fact cache will be cleared. All other values
      do nothing.

  EOD

  data_type("Enum['present', 'absent']")

  newvalue(:absent) do
    if @resource.provider and @resource.provider.respond_to?(:destroy)
      @resource.provider.destroy
    else
      @resource.destroy
    end
    nil # return nil so the event is autogenerated
  end

  def insync?(is)
    return true if resource[:refreshonly].to_s == 'true'

    super
  end
end
